@if (@CodeSection == @Batch) @then


@echo off
setlocal EnableDelayedExpansion
goto endComment


VIBORAS.bat: A multi-player version in color of Snake game
Designed and developed by Antonio Perez Ayala aka Aacini
Dedicated to Salvador Medina (a very special Snake game player)
https://www.dostips.com/forum/viewtopic.php?f=3&t=8606

Use PowerShell engine to read control keys and show text in color as described at:
http://www.dostips.com/forum/viewtopic.php?f=3&t=6936&p=46206#p46206

Version 1.0 - 2018/06/05
    Fully working preliminary version. These planned features are not yet implemented:
    - Turbo food
    - Reverse food
    - Gate/Wall food
    - Coral food
    - Lapse food
    - Snake reproduction
    - "exit" variable

Version 1.1 - 2018/06/11
    Changes in this version:
    - A pause in the animation when a food is eaten was fixed
    - Snake head character was added
    - In "Terminal 12x12.FNT" and "Terminal 16x16.FNT" files the "<>^V" characters were modified
    - The operation rules on food creation was simplified via "justFor" variable
    - Turbo food was implemented
    - Reverse food was implemented

Version 1.2 - 2018/06/30
    Changes in this version:
    - "exit" variable was implemented
    - Snake reproduction was implemented
    - Gate food planned feature was cancelled
    - Lapse food was implemented
    - "timeOut" variable new feature for food creation was added
    - Simplified users manual in Spanish was added


The full game documentation is in file "VIBORAS.bat - User's Manual.html"


:endComment

rem Check if parameter is a game definition .txt file or chaining label
for %%f in (%1) do (
   if /I "%%~Xf" equ ".txt" (
      if not exist "%~1" (
         echo Parameters definition file not found: "%~1"
         exit /B
      )
      set "gameParams=%~1"
   ) else (
      goto %1
   )
)

mode con cols=80 lines=36
chcp 850 > NUL
color 0F
echo/
for %%a in ("                         "
            "                                     "
            "                                     "
            "                              "
            "                                         "
            "                                         "
            "                                   B A T") do echo   %%~a
echo/
echo/
echo VIBORAS.bat game written by Antonio Perez Ayala aka Aacini
echo/
echo/
echo Use Left-Arrow and Right-Arrow keys to control snake direction.
echo Use Up-Arrow and Down-Arrow keys to control snake speed.
echo When the snake eats "the food", it increases its size and speed.
echo/
echo/
echo Up to four snakes can be controlled via these keys:
echo/
echo #1 Yellow Snake:  Up-Arrow,   Left-Arrow, Down-Arrow, Right-Arrow
echo/
echo #2 Green Snake:   "W" letter, "A" letter, "S" letter, "D" letter
echo/
echo #3 Magenta Snake: "G" letter, "V" letter, "B" letter, "N" letter
echo/
echo #4 Cyan Snake:    "O" letter, "K" letter, "L" letter, ";" character
echo/
echo/ 
echo Press space bar to pause or quit the game
echo/
echo/
set /P "=Press any key to start the game . . . " < NUL
pause > NUL

cls
echo/
echo               
echo                      
echo                   
echo                   
echo                           
cd /D "%~DP0" > pipeFile.txt
"%~F0" Input >> pipeFile.txt  |  "%~F0" Main < pipeFile.txt  |  "%~F0" Output
echo/
echo Ending game...
ping localhost -n 2 > NUL
del pipeFile.txt
goto :EOF


=============================================================================


:Input
                      rem Use VirtualKeyCode.bat program to know the code of any key
set "NextToL=188"  &  rem = semicolon in English keyboards
set "NextToL=192"  &  rem = letra "" en teclados en Espaol

set "letter=ABCDEFGHIJKLMNOPQRSTUVWXYZ"
for /L %%i in (0,1,25) do (
   set /A "Letter!letter:~%%i,1!=%%i+65"
)
set /A "Esc=27, Space=32, PageUp=33, Home=36, LeftArrow=37, UpArrow=38, RightArrow=39, DownArrow=40"
if not defined gameParams (
   set "snakes=1"
) else (
   for /F "delims=" %%a in ('findstr /I "snakes=" "%gameParams%"') do %%a
   for %%f in ("%gameParams%") do set "gameParams=  -  %%~Nf"
)

set "keys=            %Home%='%Home%,snk=1';        %UpArrow%='%UpArrow%,snk=1';       %PageUp%='%PageUp%,snk=1';"
set "keys=%keys% %LeftArrow%='%LeftArrow%,snk=1'; %DownArrow%='%DownArrow%,snk=1'; %RightArrow%='%RightArrow%,snk=1';"
if %snakes% geq 2 (
   set "keys=%keys% %LetterQ%='%Home%,snk=2';      %LetterW%='%UpArrow%,snk=2';   %LetterE%='%PageUp%,snk=2';"
   set "keys=!keys! %LetterA%='%LeftArrow%,snk=2'; %LetterS%='%DownArrow%,snk=2'; %LetterD%='%RightArrow%,snk=2';"
)
if %snakes% geq 3 (
   set "keys=%keys% %LetterF%='%Home%,snk=3';      %LetterG%='%UpArrow%,snk=3';   %LetterH%='%PageUp%,snk=3';"
   set "keys=!keys! %LetterV%='%LeftArrow%,snk=3'; %LetterB%='%DownArrow%,snk=3'; %LetterN%='%RightArrow%,snk=3';"
)
if %snakes% geq 4 (
   set "keys=%keys% %LetterI%='%Home%,snk=4';      %LetterO%='%UpArrow%,snk=4';   %LetterP%='%PageUp%,snk=4';"
   set "keys=!keys! %LetterK%='%LeftArrow%,snk=4'; %LetterL%='%DownArrow%,snk=4'; %NextToL%='%RightArrow%,snk=4';"
)

PowerShell  ^
   $command = @{ %Space%='%Space%'; %keys% };  ^
   Start-Sleep -m 2000;  ^
   Write-Output 0;  ^
   $console = $Host.UI.RawUI;  ^
   while ( $console.KeyAvailable ) {  ^
      $key = $console.ReadKey('NoEcho,IncludeKeyUp').VirtualKeyCode;  ^
   }  ^
   $key = 0;  ^
   while ( $key -ne %LetterN% ) {  ^
      while ( $key -ne %Space%  -and  $key -ne %Esc% ) {  ^
         $key = $console.ReadKey('NoEcho,IncludeKeyUp').VirtualKeyCode;  ^
         Write-Output $command[$key];  ^
      }  ^
      if ( $key -eq %Space% ) {  ^
         $console.WindowTitle = 'PAUSED  -  Continue? [Y,N]';  ^
      } else {  ^
         $console.WindowTitle = 'PLAY AGAIN? [Y,N]';  ^
      }  ^
      while ( $key -ne %LetterY%  -and  $key -ne %LetterN% ) {  ^
         $key = $console.ReadKey('NoEcho,IncludeKeyUp').VirtualKeyCode;  ^
      }  ^
      Write-Output $key;  ^
      $console.WindowTitle = 'VIBORAS.bat by Aacini%gameParams%';  ^
   }
%End PowerShell%
exit /B


=============================================================================


:Output

rem Parameters received via lines read have one of these forms:
rem - 'color',Color = Set default screen color
rem - 'beep',freq,millisecs = Play beep tone
rem - Pos = Move cursor to Position=Y<<7+X
rem - Pos,Color,'String' = Move cursor to Position and show the String in given Color

if defined gameParams for %%f in ("%gameParams%") do set "gameParams=  -  %%~Nf"

PowerShell  ^
   $console = $Host.UI.RawUI;  ^
   $console.WindowTitle = 'VIBORAS.bat by Aacini%gameParams%';  ^
   $curSize = $console.CursorSize;  ^
   $console.CursorSize = 0;  ^
   $coords = $console.CursorPosition;  ^
   foreach ( $line in $input ) {  ^
      $Pos,$Color,$String = $line.Split(',');  ^
      if ( $Pos -eq 'color' ) {  ^
         cmd /C color $Color  ^
      } elseif ( $Pos -eq 'beep' ) {  ^
         [Console]::Beep(([int]$Color),([int]$String))  ^
      } else {  ^
         $coords.Y = ([int]$Pos) -shr 7;  ^
         $coords.X = ([int]$Pos) %% 128;  ^
         $console.CursorPosition = $coords;  ^
         if ( $String ) {  ^
            $back = [int]('0x'+$Color[0]);  ^
            $fore = [int]('0x'+$Color[1]);  ^
            Write-Host  -BackgroundColor $back  -ForegroundColor $fore  -NoNewLine  $String  ^
         }  ^
      }  ^
   }  ^
   $console.CursorSize = $curSize;
%End PowerShell%
exit /B


=============================================================================


:Main

rem Empty environment
(
   for /F "delims==" %%v in ('set') do set "%%v="
   set "path=%path%"
   set "SystemRoot=%SystemRoot%"
   set "gameParams=%gameParams%"
)


rem Define a basic game: standard size 80x36, single player, one standard food, no reserved foods, no eggs, standard exit
set /A cols=80, lines=36, snakes=1, stdFoods=1, resFoods=0, eggSizeP5=9999, exit=0


if defined gameParams (
   rem Read game parameters from given file
   for /F "usebackq delims=" %%a in ("%gameParams%") do %%a
   set "gameParams="
   if defined eggSize set /A "eggSizeP5=eggSize+5"
)
for /L %%S in (1,1,%snakes%) do if not defined name[%%S] set "name[%%S]=SNAKE #%%S"


REM Define control movement variables

set /A "PageUp=33, Home=36, LeftArrow=37, UpArrow=38, RightArrow=39, DownArrow=40"
set /A "ToRight=1, ToLeft=-1, ToDown=128, ToUp=-128"
set "turn[%ToRight%+%RightArrow%]=%ToDown%"  &  set "turn[%ToRight%+%LeftArrow%]=%ToUp%"
set "turn[%ToDown%+%RightArrow%]=%ToLeft%"   &  set "turn[%ToUp%+%LeftArrow%]=%ToLeft%"
set "turn[%ToLeft%+%RightArrow%]=%ToUp%"     &  set "turn[%ToLeft%+%LeftArrow%]=%ToDown%"
set "turn[%ToUp%+%RightArrow%]=%ToRight%"    &  set "turn[%ToDown%+%LeftArrow%]=%ToRight%"


REM Define other configuration parameters you may modify

rem Initial, maximum and stop snake speeds (as inverse delays); initial snake size
set /A "maxDelay=50, minDelay=12, stopDel=9999,  initSize=5"
rem Formula for decrease delay (increase speed) each time a food is eaten
set "delayDec=(delay[%%S]*19)/20"
rem Snake colors (yellow, green, magenta, cyan, and background) and head/body/egg characters
set "color[1]=E0" & set "color[2]=A0" & set "color[3]=D0" & set "color[4]=B0" & set "color[0]=0F"
set "head[%ToRight%]=>" & set "head[%ToLeft%]=<" & set "head[%ToDown%]=V" & set "head[%ToUp%]=^"
set "body[%ToRight%]=" & set "body[%ToLeft%]=" & set "body[%ToDown%]=" & set "body[%ToUp%]="
set "body[%ToRight%+%RightArrow%]="  &  set "body[%ToUp%+%LeftArrow%]="
set "body[%ToDown%+%RightArrow%]="   &  set "body[%ToRight%+%LeftArrow%]="
set "body[%ToLeft%+%RightArrow%]="   &  set "body[%ToDown%+%LeftArrow%]="
set "body[%ToUp%+%RightArrow%]="     &  set "body[%ToLeft%+%LeftArrow%]="
rem Beep frequencies for food eaten per snake, and snake crash
set /A "beep[1]=660, beep[2]=524, beep[3]=392, beep[4]=330, beep[0]=262"


REM Initialize "board" variable with all board positions, from 0 up to 8063,
REM with characters that indicate cell contents: <space> = free cell, "X" letter = frame

set "board= "
for /L %%i in (1,1,12) do set "board=!board!!board!"
set "board=!board:~0,4032!!board:~0,4032!"
set /A "colsM1=cols-1, linesM1=lines-1, aux1=(linesM1<<7)+colsM1"
set "board=!board:~0,%aux1%!"
rem Frame, top and bottom
for /L %%x in (0,1,%colsM1%) do (
   set /A "top=%%x, topP1=top+1,  bot=(linesM1<<7)+%%x, botP1=bot+1"
   for /F "tokens=1-4" %%i in ("!top! !topP1! !bot! !botP1!") do (
      set "board=!board:~0,%%i!X!board:~%%j!"
      set "board=!board:~0,%%k!X!board:~%%l!"
   )
)
rem Frame, left and right
for /L %%y in (0,1,%linesM1%) do (
   set /A "lef=%%y<<7, lefP1=lef+1,  rig=(%%y<<7)+colsM1, rigP1=rig+1"
   for /F "tokens=1-4" %%i in ("!lef! !lefP1! !rig! !rigP1!") do (
      set "board=!board:~0,%%i!X!board:~%%j!"
      set "board=!board:~0,%%k!X!board:~%%l!"
   )
)
for %%v in (colsM1 linesM1 top topP1 bot botP1 lef lefP1 rig rigP1) do set "%%v="


REM Initialize "free" variable with up to 1632 positions comprised:  ** ** **
REM of 4 digits + one space each that form a sample taken from the:  ** ** **
REM total positions distributed in 9 "islands", as shown here:       ** ** **

rem Get number of colsFree:linesFree with the same cols:lines original relation
set /A "maxFree=1632, colsM2=cols-2, linesM2=lines-2, N=maxFree*linesM2/colsM2, Next=N/2, linesFree=N/Next"
for /L %%# in (1,1,6) do if !Next! gtr !linesFree! set /A "Next=(Next+linesFree)/2, linesFree=N/Next"
set /A "colsFree=(maxFree-1)/linesFree+1"
rem Get linesFree omitting 2 groups of lines at 1/3 and 2/3 from the total lines; see scheme above
set /A "m=linesM2-linesFree, l1=linesM2/3-m/4-1, l2=l1+m/2-1, l4=linesM2*2/3+m/4+3, l3=l4-(m-m/2)+1"
set "linesFree= "
for /L %%y in (1,1,%linesM2%) do set "linesFree=!linesFree!%%y "
if %m% geq 2 (
   set "linesFree=!linesFree: 1 = !"
   set "linesFree=!linesFree: %linesM2% = !"
   set /A l2-=1, l3+=1, m-=2
)
if %m% geq 2 (
   for /L %%y in (%l1%,1,%l2%) do set "linesFree=!linesFree: %%y = !"
   for /L %%y in (%l3%,1,%l4%) do set "linesFree=!linesFree: %%y = !"
)
rem Get colsFree omitting 2 groups of columns at 1/3 and 2/3 from the total columns; see scheme above
set /A "m=colsM2-colsFree, l1=colsM2/3-m/4-1, l2=l1+m/2-1, l4=colsM2*2/3+m/4+3, l3=l4-(m-m/2)+1"
set "colsFree= "
for /L %%x in (1,1,%colsM2%) do set "colsFree=!colsFree!%%x "
if %m% geq 2 (
   set "colsFree=!colsFree: 1 = !"
   set "colsFree=!colsFree: %colsM2% = !"
   set /A l2-=1, l3+=1, m-=2
)
if %m% geq 2 (
   for /L %%x in (%l1%,1,%l2%) do set "colsFree=!colsFree: %%x = !"
   for /L %%x in (%l3%,1,%l4%) do set "colsFree=!colsFree: %%x = !"
)
rem Create up to maxFree free positions from linesFree:colsFree
set "free= "
set "freeLen=0"
for %%y in (%linesFree%) do (
   for %%x in (%colsFree%) do if !freeLen! lss %maxFree% (
      set /A "m=(%%y<<7)+%%x, freeLen+=1"
      set "m=   !m!"
      set "free=!free!!m:~-4! "
   )
)
rem Remove free positions from a 7x7 square placed at center
set /A "maxFree=freeLen, freeLen-=7*7, center=(lines/2<<7)+cols/2, l1=center+3*ToUp+3*ToLeft, l3=l1+6*ToDown"
for /L %%y in (%l1%,%ToDown%,%l3%) do (
   set /A "l4=%%y+6*ToRight"
   for /L %%x in (%%y,%ToRight%,!l4!) do (
      set "m=   %%x"
      for %%m in ("!m:~-4!") do set "free=!free:%%~m =!"
   )
)
for %%v in (N Next linesFree colsFree m l1 l2 l3 l4) do set "%%v="


REM General use variables

set "spaces=         "
rem Status area variables
if %snakes% equ 1 (
   set /A "aux2=0, aux1=cols/2-6"
) else (
   set /A "aux2=cols/snakes, aux1=cols-aux2"
)
for /L %%S in (1,1,%snakes%) do (
   set /A "status[%%S]=(lines+1<<7)+aux1+6,aux1=(aux1+aux2)%%cols"
)
rem Food to grow: Standard and Boost
set "grow=123456789"
rem Eggs as "food"
set "egg=><V^^"
rem Food to store: Turbo, Wall and Reverse
set "store=TWR"
set /A "T=1,W=2,R=3"
rem Turn/answer keys, aux1 = height of the screen for mode command *below*
set "turn=/%LeftArrow%/%RightArrow%/"
set /A "LetterN=78, LetterY=89,  aux1=lines+6"
rem Randomize
for /L %%i in (1,1,%time:~-2%) do set "aux2=!random!"


set "input="
:WaitPS for PowerShell Input part start signal
   set /P "input="
if not defined input goto WaitPS


if not defined init set "init=1"

%/* Main loop */%
for /L %%# in () do (


   %/* Section 0- Initialization module */%

   if defined init (
      setlocal EnableDelayedExpansion
      set /A "%init%"
      set "init="

      %/* Show the initial board */%

      %/* color command not work here, execute it in PS */%
      echo color,%color[0]%
      set "aux1="
      for /L %%i in (1,1,%colsM2%) do set "aux1=!aux1! "
      %/* cls command not work here, use mode instead */%
      mode con cols=%cols% lines=%aux1%
      < NUL (
         set /P "=!aux1: =!"
         for /L %%i in (1,1,%linesM2%) do set /P "=!aux1!"
         set /P "=!aux1: =!"
      ) > CON
      for /L %%S in (1,1,%snakes%) do (
         echo !status[%%S]!,%color[0]:~0,1%!color[%%S]:~0,1!,!name[%%S]!
         set /A "aux1=status[%%S]+ToDown, aux2=aux1+ToDown"
         echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,Size: %initSize%
         echo !aux2!,%color[0]:~0,1%!color[%%S]:~0,1!,Del: %maxDelay%
      )
      echo %center%,%color[0]%,

      %/* Get the initial Standard-Foods from "free" and insert they in "board" */%

      for /L %%n in (1,1,%stdFoods%) do (
         set /A "aux1=(!random!%%freeLen)*5+1, aux2=aux1+5"
         for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
            set /A "aux1=!free:~%%i,4!, aux2=aux1+1, freeLen-=1"
            set "free=!free:~0,%%i!!free:~%%j!"
         )
         echo !aux1!,%color[0]%,1
         for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
            set "board=!board:~0,%%i!1!board:~%%j!"
         )
      )

      %/* Get the initial Reserved-Foods from "free" and insert they in "board" */%

      for /L %%S in (1,1,%snakes%) do (
         for /L %%n in (1,1,%resFoods%) do (
            set /A "aux1=(!random!%%freeLen)*5+1, aux2=aux1+5"
            for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
               set /A "aux1=!free:~%%i,4!, aux2=aux1+1, freeLen-=1"
               set "free=!free:~0,%%i!!free:~%%j!"
            )
            echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,1
            for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
               set "board=!board:~0,%%i!1!board:~%%j!"
            )
            set "resFood[!aux1!]=%%S"
         )
      )

      %/* Initialize the snakes */%
      %/* Percent expansion of "snakes" is a *constant* with the number of snakes */%
      %/* Exclamation-mark expansion of "snakes" contain the live snakes at any moment */%

      set "snakes= "
      for /L %%S in (1,1,%snakes%) do (
         set "snakes=!snakes!%%S "
         set /A "headPos[%%S]=tailPos[%%S]=center, size[%%S]=tailGrow[%%S]=initSize, headSize[%%S]=nodes[%%S]=0"
         set /A "del[%%S]=delay[%%S]=maxDelay, beg[%%S]=1!time:~-4,1!!time:~-2!,  T[%%S]=W[%%S]=R[%%S]=0"
                if %%S equ 1 ( set /A "headMov[1]=tailMov[1]=toRight"
         ) else if %%S equ 2 ( set /A "headMov[2]=tailMov[2]=toLeft"
         ) else if %%S equ 3 ( set /A "headMov[3]=tailMov[3]=toDown"
         ) else if %%S equ 4   set /A "headMov[4]=tailMov[4]=toUp"
      )

      set /A "minSize=maxSize=initSize, minSnake=maxSnake=1, seconds=0, lastSec=-1"

   )  %/* End init */%


   %/* Section 1- Timer module, for asynchronous events based on seconds */%

   if "!lastSec!" neq "!time:~7,1!" (
      set /A "seconds+=1, lastSec=!time:~7,1!,  aux1=(lines-1<<7)+cols/2-11"
      echo !aux1!,%color[0]%, !time:~0,8!  !seconds! 

      %/* Test if Lapse mode completed, and cancel it */%
      if defined LapseSecs (
         set /A LapseSecs-=1
         if !LapseSecs! gtr 0 (
            for %%S in (!snakes!) do if "%%S" neq "!LapseSnake!" (
               set /A "aux1=status[%%S]+3*ToDown"
               echo !aux1!,!color[%%S]:~0,1!%color[0]:~0,1%,Lapse !LapseSecs! 
            )
         ) else (
            set "LapseSecs="
            for %%S in (!snakes!) do if "%%S" neq "!LapseSnake!" (
               set /A "del[%%S]=delay[%%S], aux1=status[%%S]+3*ToDown"
               echo !aux1!,%color[0]%,%spaces:~0,9%
            )
            set "LapseSnake="
            set "LapseFood="
         )
      ) else (
         %/* Test for timeOut foods, and cancel them */%
         set "aux3=0"
         if defined timeOut (
            for /F "tokens=2-4 delims=[;]" %%i in ('set timeOut[ 2^>NUL') do (
               set /A "aux1=(timeOut[%%i;%%j;%%k]-=1), aux2=aux1&1, aux3+=1"
               if !aux1! lss 10 (
                  if !aux2! equ 1 (
                     %/* Blink digit on odd seconds */%
                     echo %%i,%%j,!aux1!
                  ) else if !aux1! gtr 0 (
                     %/* Blink food on even seconds */%
                     echo %%i,%%j,%%k
                  ) else (
                     %/* Clear food on time out */%
                     echo %%i,%color[0]%,%spaces:~0,1%
                     set "timeOut[%%i;%%j;%%k]="
                     if "%%k" equ "L" set "LapseFood="   %/* Cancel uneaten LapseFood */%
                     set /A "aux2=%%i+1, aux3-=1"
                     for /F %%j in ("!aux2!") do set "board=!board:~0,%%i! !board:~%%j!"
                  )
               )
            )
            if !aux3! equ 0 set "timeOut="
         )
      )


   )  %/* End Timer module */%


   %/* Section 2- Control module. Get and process input keys, or check if delay interval ends */%

   set "S="
   set "input="
   set /P "input="
   if defined input (

      set /A "key=!input!"  %/* and snk=Snake# */%
      if "!key!" equ "32" (  %/* Space */%
         call :Pause
         for /L %%S in (1,1,%snakes%) do set "beg[%%S]=1!time:~-4,1!!time:~-2!"
      ) else for /F %%S in ("!snk!") do (

         %/* Cancel input keys of crashed snakes, if any */%
         if "!snakes:%%S=!" equ "!snakes!" set "key=0"

         %/* Cancel input keys of stopped snakes in Lapse mode */%
         if defined LapseSnake if "%%S" neq "!LapseSnake!" set "key=0"

         %/* Identify the input key */%
         for /F "tokens=1,2" %%j in ("!headMov[%%S]! !key!") do (

            if "!turn:/%%k/=!" neq "%turn%" (
               %/* LeftArrow or RightArrow, change head direction and create a "node" */%
               set "prevChar[%%S]=!body[%%j+%%k]!"
               set "headMov[%%S]=!turn[%%j+%%k]!"
               set "node[!headPos[%%S]!]=%%j+%%k !headSize[%%S]!"
               %/* Force immediate snake movement via S=snake# */%
               set /A "beg[%%S]=1!time:~-4,1!!time:~-2!, headSize[%%S]=0, nodes[%%S]+=1, S=%%S"

            ) else if !key! equ %UpArrow% (
               %/* Process Slow/Normal/Turbo speeds /%
               set /A "aux1=delay[%%S]*2"
               if !del[%%S]! equ %stopDel% (
                  set "del[%%S]=!aux1!"
                  set "mode2=Slow "
               ) else if !del[%%S]! equ !aux1! (
                  set "del[%%S]=!delay[%%S]!"
                  set "mode2=     "
               ) else if !del[%%S]! equ !delay[%%S]! (
                  if !T[%%S]! gtr 0 (
                     set /A "T[%%S]-=1, del[%%S]=delay[%%S]/2"
                     set "mode1=T" & set "mode2=Turbo"
                  )
               )

            ) else if !key! equ %DownArrow% (
               %/* Process Normal/Slow/Stop speeds and Reverse direction */%
               set /A "aux1=delay[%%S]*2, aux2=delay[%%S]/2"
               if !del[%%S]! equ !aux2! (
                  set "del[%%S]=!delay[%%S]!"
                  set "mode2=     "
               ) else if !del[%%S]! equ !delay[%%S]! (
                  set "del[%%S]=!aux1!"
                  set "mode2=Slow "
               ) else if !del[%%S]! equ !aux1! (
                  set "del[%%S]=%stopDel%"
                  set "mode2=Stop "
               ) else if !R[%%S]! gtr 0 (  %/* Change direction to reverse */%
                  %/* Exchange Head/Tail movement and position.   Get position of first node in aux1 */%
                  set /A "R[%%S]-=1, aux1=headMov[%%S], headMov[%%S]=-tailMov[%%S], tailMov[%%S]=-aux1"
                  set /A "aux2=headPos[%%S], headPos[%%S]=tailPos[%%S], tailPos[%%S]=aux2, aux1=aux2+(aux3=-headSize[%%S])"
                  %/* Process the linked-list of nodes */%
                  for /L %%# in (1,1,!nodes[%%S]!) do for /F %%N in ("!aux1!") do for /F "tokens=1,2" %%i in ("!node[%%N]!") do (
                     %/* Get the opposite turn direction of this node */%
                     set "aux2=%%i"
                     set "key=!aux2:%RightArrow%=%LeftArrow%!"
                     if "!aux2!" neq "!key!" (
                        set "aux2=!key!"
                        for %%c in ("%ToUp%=%ToLeft%" "%ToLeft%=%ToDown%" "%ToDown%=%ToRight%" "%ToRight%=%ToUp%") do (
                           if "!aux2!" equ "!key!" set "aux2=!aux2:%%~c!"
                        )
                     ) else (
                        set "key=!aux2:%LeftArrow%=%RightArrow%!"
                        set "aux2=!key!"
                        for %%c in ("%ToUp%=%ToRight%" "%ToLeft%=%ToUp%" "%ToDown%=%ToLeft%" "%ToRight%=%ToDown%") do (
                           if "!aux2!" equ "!key!" set "aux2=!aux2:%%~c!"
                        )
                     )
                     %/* Update turn direction of this node and size of *previous* node */%
                     set "node[%%N]=!aux2! !aux3!"
                     %/* Keep position of last node in aux2. Pass to next node */%
                     set /A "aux2=aux1, aux1+=(aux3=-%%j)"
                  )
                  set /A "headSize[%%S]=headPos[%%S]-aux2, del[%%S]=(delay[%%S]*=2)"
                  if !del[%%S]! gtr %maxDelay% set /A "del[%%S]=delay[%%S]=maxDelay"
                  for /F %%j in ("!headMov[%%S]!") do set "prevChar[%%S]=!body[%%j]!"
                  set "mode1=R" & set "mode2=     "
               )

            ) else if !key! equ %Home% (
               rem TO DO: Process insert Wall

            ) else if !key! equ %PageUp%  if !size[%%S]! gtr %eggSizeP5%  if not defined egg[%%S] (  %/* Lay an egg */%
               %/* Decrease snake size and speed, and create the egg */%
               set /A "size[%%S]-=eggSize, del[%%S]=(delay[%%S]*=2), aux1=status[%%S]+ToDown, aux2=aux1+ToDown, aux3=eggSize/2"
               if !del[%%S]! gtr %maxDelay% set /A "del[%%S]=delay[%%S]=maxDelay"
               echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,Size: !size[%%S]!  
               echo !aux2!,%color[0]:~0,1%!color[%%S]:~0,1!,Del: !del[%%S]!  
               if !size[%%S]! lss !minSize! set /A "minSize=size[%%S], minSnake=%%S"
               set "egg[%%S]=!tailMov[%%S]! !tailPos[%%S]! !aux3! !delay[%%S]!"
               set "resFood[!tailPos[%%S]!]=%%S"
               %/* Shrink snake body */%
               for /L %%i in (1,1,%eggSize%) do (
                  %/* Delete last tail */%
                  echo !tailPos[%%S]!,%color[0]%,%spaces:~0,1%
                  set /A "aux1=tailPos[%%S]+1"
                  for /F "tokens=1,2" %%i in ("!tailPos[%%S]! !aux1!") do (
                     set "board=!board:~0,%%i! !board:~%%j!"
                  )
                  %/* Advance tail, if reaches a "node" change direction */%
                  set /A "tailPos[%%S]+=tailMov[%%S]"
                  if defined node[!tailPos[%%S]!] for /F %%i in ("!tailPos[%%S]!") do for /F %%j in ("!node[%%i]!") do (
                     set "tailMov[%%S]=!turn[%%j]!"
                     set "node[!tailPos[%%S]!]="
                     set /A "nodes[%%S]-=1"
                  )
               )
               %/* Lay the egg */%
               for /F "tokens=1,2" %%i in ("!egg[%%S]!") do (
                  echo %%j,!color[%%S]!,!head[%%i]!
                  set /A "aux1=%%j+1"
                  for /F %%k in ("!aux1!") do (
                     set "board=!board:~0,%%j!!head[%%i]!!board:~%%k!"
                  )
               )

            )

            if defined mode1 (
               %/* Show/Clear one-letter status. T,W,R with numbers */%
               set /A "aux1=status[%%S]+!mode1!*ToDown+5*ToLeft, key=!mode1![%%S]"
               set "aux2=   " & set "aux3= "
               if !key! gtr 0 (
                  set "aux3=!mode1!"
                  if !key! gtr 1 set "aux2= !key!x"
               )
               echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,!aux2:~-3!!aux3!
               set "mode1="
            )

            if defined mode2 (
               %/* Show/Clear message status. Stop, Slow and Turbo */%
               set /A "aux1=status[%%S]+2*ToDown, aux2=aux1+ToDown"
               echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,Del: !del[%%S]!  
               if "!mode2!" equ "     " (
                  echo !aux2!,%color[0]%,!mode2!
               ) else (
                  echo !aux2!,!color[%%S]:~0,1!%color[0]:~0,1%,!mode2!
               )
               set "mode2="
            )

         )  %/* End Identify input key */%

      )
   ) else (
      %/* No input key, test if delay had passed */%
      for /L %%S in (1,1,%snakes%) do if not defined S (
         set /A "end[%%S]=1!time:~-4,1!!time:~-2!, elap=end[%%S]-beg[%%S], elap-=(elap>>31)*1000"
         if !elap! geq !del[%%S]! set /A "beg[%%S]=1!time:~-4,1!!time:~-2!, S=%%S"
      )
   )  %/* End Control module */%


   %/* Section 3- Move the Snake specified by S variable */%

   for /F %%S in ("!S!") do (

      %/* Update tail */%

      if !tailGrow[%%S]! gtr 0 (
         %/* Snake is growing, just blink tail segment */%
         set /A "aux1=tailGrow[%%S]&1, tailGrow[%%S]-=1"
         for /F %%j in ("!tailMov[%%S]!") do if !aux1! equ 1 (set "aux1=!head[%%j]!") else set "aux1= "
         echo !tailPos[%%S]!,!color[%%S]!,!aux1!
      ) else (
         %/* Delete last tail */%
         echo !tailPos[%%S]!,%color[0]%,%spaces:~0,1%
         set /A "aux1=tailPos[%%S]+1"
         for /F "tokens=1,2" %%i in ("!tailPos[%%S]! !aux1!") do (
            set "board=!board:~0,%%i! !board:~%%j!"
         )
         %/* Insert last tail in "free", if needed */%
         if !freeLen! lss %maxFree% (
            set "aux1=   !tailPos[%%S]!"
            set "free=!free!!aux1:~-4! "
            set /A freeLen+=1
         )
         %/* Advance tail */%
         set /A "tailPos[%%S]+=tailMov[%%S]"
         if !tailPos[%%S]! equ !headPos[%%S]! (
            %/* The body of a crashed snake was completely removed */%
            if not defined egg[%%S] (
               %/* Crashed snake die */%
               set "del[%%S]=%stopDel%"  %/* exit gtr 0 */%
            ) else (
               %/* Crashed snake's daugther hatchs out */%
               for /F "tokens=1-4" %%i in ("!egg[%%S]!") do (
                  set /A "headMov[%%S]=tailMov[%%S]=%%i, headPos[%%S]=tailPos[%%S]=%%j, size[%%S]=tailGrow[%%S]=%%k"
                  set /A "del[%%S]=delay[%%S]=%%l, headSize[%%S]=nodes[%%S]=0, beg[%%S]=1!time:~-4,1!!time:~-2!"
               )
               set /A "aux1=status[%%S]+ToDown, aux2=aux1+ToDown"
               echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,Size: !size[%%S]!
               echo !aux2!,%color[0]:~0,1%!color[%%S]:~0,1!,Del: !del[%%S]!
               if !size[%%S]! lss !minSize! set /A "minSize=size[%%S], minSnake=%%S"
               set "egg[%%S]="
            )
         )
         %/* If tail reaches a "node", change direction */%
         if defined node[!tailPos[%%S]!] for /F %%i in ("!tailPos[%%S]!") do for /F %%j in ("!node[%%i]!") do (
            set "tailMov[%%S]=!turn[%%j]!"
            set "node[!tailPos[%%S]!]="
            set /A "nodes[%%S]-=1"
         )
      )

      %/* Advance head and process the new position */%

      set /A "prevPos[%%S]=headPos[%%S], headPos[%%S]+=headMov[%%S], headSize[%%S]+=headMov[%%S]"
      for /F %%i in ("!headPos[%%S]!") do for /F "delims=" %%c in ("!board:~%%i,1!") do (
         set "headChar=%%c"

         %/* Test if this is a reserved food or position */%
         set "aux1=OK"
         if defined resFood[%%i] if "!resFood[%%i]!" neq "%%S" set "aux1="
         if defined aux1 (

            %/* Identify the character at this position */%

            if "!grow:%%c=!" neq "%grow%" (
               %/* Food to grow; eat it */%
               set /A "size[%%S]+=%%c, tailGrow[%%S]+=%%c"
               if !delay[%%S]! gtr %minDelay% set /A "delay[%%S]=%delayDec%"
               set "beep=!beep[%%S]!"
               %/* Get the next food position from "free" */%
               set /A "aux1=(!random!%%freeLen)*5+1, aux2=aux1+5"
               for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
                  set /A "aux1=!free:~%%i,4!, aux2=aux1+1, freeLen-=1"
                  set "free=!free:~0,%%i!!free:~%%j!"
               )
               set "aux3=1"
               if defined resFood[%%i] (
                  set "resFood[%%i]="
                  %/* The new food must also be reserved for this snake */%
                  if defined ResBoost (
                     set /A "aux3=%ResBoost%"
                     if !aux3! lss 1 (set "aux3=1") else if !aux3! gtr 9 set "aux3=9"
                  )
                  echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,!aux3!
                  set "resFood[!aux1!]=%%S"
               ) else (
                  if defined StdBoost (
                     set /A "aux3=%StdBoost%"
                     if !aux3! lss 1 (set "aux3=1") else if !aux3! gtr 9 set "aux3=9"
                  )
                  echo !aux1!,%color[0]%,!aux3!
               )
               %/* Insert the new food in "board" */%
               for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
                  set "board=!board:~0,%%i!!aux3!!board:~%%j!"
               )
               set "headChar= "

            ) else if "!egg:%%c=!" neq "%egg%" (
               %/* Own egg as food; recover half the size used to create it */%
               set "egg[%%S]="
               set /A "size[%%S]+=eggSize/2, tailGrow[%%S]+=eggSize/2
               if !delay[%%S]! gtr %minDelay% set /A "delay[%%S]=%delayDec%"
               set "beep=!beep[%%S]!"
               set "headChar= "

            ) else if "!store:%%c=!" neq "%store%" (
               %/* Turbo, Reverse, or Wall food; store it in this snake /*%
               set /A "%%c[%%S]+=1, aux1=status[%%S]+%%c*ToDown+5*ToLeft"
               if !%%c[%%S]! equ 1 (set "aux2=   ") else set "aux2= !%%c[%%S]!x"
               echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,!aux2:~-3!%%c
               set "beep=!beep[%%S]!"
               set "headChar= "

            ) else if "%%c" equ "L" (
               %/* Lapse food; enable Lapse mode for this snake... */%
               set /A "LapseSnake=%%S, LapseSecs=LapseFood"
               for %%S in (!snakes!) do if "%%S" neq "!LapseSnake!" (
                  set /A "del[%%S]=stopDel, aux1=status[%%S]+3*ToDown"
                  echo !aux1!,!color[%%S]:~0,1!%color[0]:~0,1%,Lapse !LapseSecs! 
               )
               set "beep=!beep[%%S]!"
               set "headChar= "

            ) else if "%%c" equ "C" (
               %/* Coral food */%
               rem TO DO: Set values to convert this snake in a Coral one
               set "beep=!beep[%%S]!"
               set "headChar= "

            )  %/* End Identify this character */%

            %/* If this food was eaten and have a time out, cancel the time out */%
            if "!headChar!" equ " " if defined timeOut for /F "tokens=2-4 delims=[;]" %%I in ('set timeOut[%%i; 2^>NUL') do (
               set "timeOut[%%I;%%J;%%K]="
            )

         )  %/* endIf identify the character at this position */%

      )  %/* endFor /F i in "headPos[S]" do ... */%


      %/* If new head position is valid */%

      if !headMov[%%S]! equ 0 set "headChar= "  %/* exit gtr 0 */%

      if "!headChar!" equ " " (
         %/* Advance the snake */%
         set /A "aux1=headPos[%%S]+1"
         set "aux2=   !headPos[%%S]!"
         for /F "tokens=1-4 delims=," %%i in ("!headPos[%%S]!,!headMov[%%S]!,!aux1!,!aux2:~-4!") do (
            if !headMov[%%S]! neq 0 (   %/* exit gtr 0 */%
               %/* Show head at new position */%
               echo !prevPos[%%S]!,!color[%%S]!,!prevChar[%%S]!
               set "prevChar[%%S]=!body[%%j]!"
               echo %%i,!color[%%S]!,!head[%%j]!
               %/* Update "board" variable */%
               set "board=!board:~0,%%i!#!board:~%%k!"
            )
            %/* If new head position is in "free" variable, remove it */%
            set "aux1=!free: %%l = !"
            if "!aux1!" neq "!free!" (
               set "free=!aux1!"
               set /A freeLen-=1
            )
         )
         if defined beep (
            %/* A food was eaten */%
            echo beep,!beep!,300
            set "beep="
            %/* Cancel Turbo, Slow and Stop modes, if any, and update status */%
            set /A "del[%%S]=delay[%%S], aux1=status[%%S]+ToDown, aux2=aux1+ToDown, aux3=aux2+ToDown"
            echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,Size: !size[%%S]!   
            echo !aux2!,%color[0]:~0,1%!color[%%S]:~0,1!,Del: !delay[%%S]!  
            echo !aux3!,%color[0]%,%spaces:~0,5%
            %/* Update smallest and largest snakes */%
            set /A "minSize=9999, maxSize=0"
            for %%S in (!snakes!) do (
               if !size[%%S]! lss !minSize! set /A "minSize=size[%%S], minSnake=%%S"
               if !size[%%S]! gtr !maxSize! set /A "maxSize=size[%%S], maxSnake=%%S"
            )
            %/* Reset all timers */%
            for /L %%S in (1,1,%snakes%) do set /A "beg[%%S]=1!time:~-4,1!!time:~-2!"
         )
      ) else (
         call :SnakeCrash %%S
         if defined egg[%%S] (
            %/* Daughter snake must hatch out... */%
            if errorlevel 3 (
               %/* ... immediately, keeping mother's body */%
               for /F "tokens=1-4" %%i in ("!egg[%%S]!") do (
                  set /A "headMov[%%S]=tailMov[%%S]=%%i, headPos[%%S]=tailPos[%%S]=%%j, size[%%S]=tailGrow[%%S]=%%k"
                  set /A "del[%%S]=delay[%%S]=%%l, headSize[%%S]=nodes[%%S]=0, beg[%%S]=1!time:~-4,1!!time:~-2!"
               )
               set /A "aux1=status[%%S]+ToDown, aux2=aux1+ToDown"
               echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,Size: !size[%%S]!
               echo !aux2!,%color[0]:~0,1%!color[%%S]:~0,1!,Del: !del[%%S]!
               if !size[%%S]! lss !minSize! set /A "minSize=size[%%S], minSnake=%%S"
               set "egg[%%S]="
            ) else (
               %/* ... after mother's body was removed */%
               set "headMov[%%S]=0"  %/* exit gtr 0 */%
            )
         ) else if errorlevel 2 (
            %/* Continue game, keep crashed snake */%
            set "del[%%S]=%stopDel%"  %/* exit gtr 0 */%
         ) else if errorlevel 1 (
            %/* Continue game, remove crashed snake */%
            set "headMov[%%S]=0"  %/* exit gtr 0 */%
         ) else (
            %/* Start a new game */%
            endlocal
         )
      )

   )  %/* End move snake */%


   %/* Section 4- Create the diverse types of food, one per cycle, and insert they in board */%

   set "food="
   set "justFor=0"
   if defined Turbo set /A "aux1=%Turbo%" & if !aux1! gtr 0 set "food=T"
   if not defined food (
      if defined Reverse set /A "aux1=%Reverse%" & if !aux1! gtr 0 set "food=R"
   )
   if not defined food (
      if defined Wall set /A "aux1=%Wall%" & if !aux1! gtr 0 set "WallFood=!aux1!" & set "food=W"
   )
   if not defined food (
      if defined Lapse (
         set /A "aux1=%Lapse%"
         if !aux1! gtr 0 if !justFor! leq 4 if not defined LapseFood (
            set "aux2=0"
            for %%S in (!snakes!) do set /A "aux2+=1"
            if !aux2! gtr 1 set "LapseFood=!aux1!" & set "food=L"
         )
      )
   )
   if not defined food (
      if defined Coral set /A "aux1=%Coral%" & if !aux1! gtr 0 set "food=C"
   )

   if defined food (
      %/* Get the next food position from "free" */%
      set /A "aux1=(!random!%%freeLen)*5+1, aux2=aux1+5"
      for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
         set /A "aux1=!free:~%%i,4!, aux2=aux1+1, freeLen-=1"
         set "free=!free:~0,%%i!!free:~%%j!"
      )
      for /F %%J in ("!justFor!") do if !justFor! leq 0 (
         %/* Standard food */%
         for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
            set "board=!board:~0,%%i!!food!!board:~%%j!"
         )
         echo !aux1!,%color[0]%,!food!
         if defined timeOut set "timeOut[!aux1!;%color[0]%;!food!]=!timeOut!"
      ) else if !justFor! leq 4 (
         %/* Reserved food just for one *live* snake */%
         if "!snakes:%%J=!" neq "!snakes!" (
            for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
               set "board=!board:~0,%%i!!food!!board:~%%j!"
            )
            echo !aux1!,%color[0]:~0,1%!color[%%J]:~0,1!,!food!
            if defined timeOut set "timeOut[!aux1!;%color[0]:~0,1%!color[%%J]:~0,1!;!food!]=!timeOut!"
            set "resFood[!aux1!]=%%J"
         )
      ) else (
         %/* Reserved food for each *live* snake */%
         for %%S in (!snakes!) do (
            %/* Get the next food position and insert the food */%
            set /A "aux1=(!random!%%freeLen)*5+1, aux2=aux1+5"
            for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
               set /A "aux1=!free:~%%i,4!, aux2=aux1+1, freeLen-=1"
               set "free=!free:~0,%%i!!free:~%%j!"
            )
            for /F "tokens=1,2" %%i in ("!aux1! !aux2!") do (
               set "board=!board:~0,%%i!!food!!board:~%%j!"
            )
            echo !aux1!,%color[0]:~0,1%!color[%%S]:~0,1!,!food!
            if defined timeOut set "timeOut[!aux1!;%color[0]:~0,1%!color[%%S]:~0,1!;!food!]=!timeOut!"
            set "resFood[!aux1!]=%%S"
         )
      )
   )  %/* End create food and insert it in board */%

)  %/* End Main loop */%
exit never reached


:Pause
   set "key="
   set /P "key="
   if "%key%" equ "%LetterY%" exit /B
if "%key%" neq "%LetterN%" goto Pause
echo %status[1]%
exit


:SnakeCrash #Snake

set /A "aux1=status[%1]+3*ToDown"
if not defined egg[%1] set "snakes=!snakes: %1 = !"
if "!snakes!" equ " " set "exit=0"
if %exit% equ 0 goto endGame

%/* There are more snakes and exit>0, continue game */%
for /L %%i in (1,1,3) do (
   echo %aux1%,!color[%1]:~0,1!%color[0]:~0,1%,Crash
   echo !headPos[%1]!,%color[0]%,!headChar!
   echo beep,%beep[0]%,600
   echo %aux1%,%color[0]%,%spaces:~0,5%
   echo !headPos[%1]!,!color[%1]!,%spaces:~0,1%
   call :Delay 80
)
if not defined egg[%1] echo %aux1%,!color[%1]:~0,1!%color[0]:~0,1%,Crash
for /F %%i in ("!headPos[%1]!") do for /F %%j in ("!resFood[%%i]!") do (
   if "!eggChars:%headChar%=!" equ "%eggChars%" (
      echo !headPos[%1]!,%color[0]:~0,1%!color[%%j]:~0,1!,!headChar!
   ) else (
      echo !headPos[%1]!,!color[%%j]!,!headChar!
   )
)
exit /B %exit%

%/* No more snakes, or first snake crashed with exit=0 */%
:endGame
CScript //nologo //E:JScript "%~F0" "{ESC}"
set "key="
:newGame
   echo !headPos[%1]!,%color[0]%,!headChar!
   echo %aux1%,!color[%1]:~0,1!%color[0]:~0,1%,Crash
   echo beep,%beep[0]%,600
   echo !headPos[%1]!,!color[%1]!,%spaces:~0,1%
   echo %aux1%,%color[0]%,%spaces:~0,5%
   call :Delay 80
   set /P "key="
   if "%key%" equ "%LetterY%" exit /B 0
if "%key%" neq "%LetterN%" goto newGame
echo %status[1]%
exit


:Delay centisecs
set "b=1%time:~-2%"
:wait
   set /A "e=1%time:~-2%, elap=e-b, elap-=(elap>>31)*100"
if %elap% lss %1 goto wait
exit /B


@end // Batch code section


// JScript code section used to send a keystroke to :Input PowerShell section
WScript.CreateObject("WScript.Shell").SendKeys(WScript.Arguments(0))

